VERSION 5.00
Begin VB.Form frmTrap 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Mouse Trap"
   ClientHeight    =   2625
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   5250
   Icon            =   "IO MouseTrap.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2625
   ScaleWidth      =   5250
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrMouseMove 
      Enabled         =   0   'False
      Interval        =   20
      Left            =   120
      Top             =   2160
   End
   Begin VB.PictureBox picMouseTrap 
      Height          =   2025
      Left            =   0
      Picture         =   "IO MouseTrap.frx":0442
      ScaleHeight     =   1965
      ScaleWidth      =   5175
      TabIndex        =   0
      Top             =   600
      Width           =   5235
   End
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "IO MouseTrap.frx":1CC4
      MousePointer    =   99  'Custom
      Picture         =   "IO MouseTrap.frx":2106
      ScaleHeight     =   615
      ScaleWidth      =   5250
      TabIndex        =   1
      Top             =   0
      Width           =   5250
   End
   Begin VB.Menu mnuMouse 
      Caption         =   "Mouse"
      Begin VB.Menu mnuTrapOn 
         Caption         =   "Trap Enabled"
      End
      Begin VB.Menu mnuQuit 
         Caption         =   "Quit"
      End
   End
End
Attribute VB_Name = "frmTrap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Mouse Trap Window
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.cool-programming.f2s.com
'
'==================================================================




'------------------------------------------------------------------
' Variables

Private Const MOVE_STEP_SIZE = 25
Private Mouse As New MouseIO

Private Type COORD
  X As Long
  Y As Long
End Type


'------------------------------------------------------------------
' Set Always on top

Private Sub Form_Initialize()
  WindowAlwaysOnTop(Me.hWnd) = True
End Sub


'------------------------------------------------------------------
' Unloading

Private Sub Form_Unload(Cancel As Integer)
  Call Mouse.UnClip
End Sub

Private Sub mnuQuit_Click()
  Unload Me
End Sub



'------------------------------------------------------------------
' Enable/Disable the trap

Private Sub mnuTrapOn_Click()
  mnuTrapOn.Checked = Not mnuTrapOn.Checked
  If mnuTrapOn.Checked Then
    MsgBox "Press ok to start the trap.", vbExclamation, "Mouse Trap"
    tmrMouseMove.Enabled = True
    ' Clip at mouseover event
  Else
    tmrMouseMove.Enabled = False
    Me.Caption = "Mouse Trap"
    Call Mouse.UnClip
  End If
End Sub


'------------------------------------------------------------------
' When over the trap...

Private Sub picMouseTrap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If tmrMouseMove.Enabled Then
    Dim WinPos As RECT
    Me.Caption = "Mouse Trapped!"
    tmrMouseMove.Enabled = False
    WinPos = WindowRect(Me.picMouseTrap.hWnd, True)
    Call Mouse.Clip(WinPos.Left, WinPos.Top, WinPos.Right, WinPos.Bottom)
  End If
End Sub


'------------------------------------------------------------------
' While not over the trap...

Private Sub tmrMouseMove_Timer()
  Dim NewPos As COORD
  Dim Target As COORD
  Dim Current As COORD
  Dim WinPos As RECT
  
  ' Get values
  Current.X = Mouse.X
  Current.Y = Mouse.Y
  WinPos = WindowRect(Me.picMouseTrap.hWnd, True)
  Target.X = (0.5 * (WinPos.Right - WinPos.Left)) + WinPos.Left
  Target.Y = (0.5 * (WinPos.Bottom - WinPos.Top)) + WinPos.Top
  
  ' Calc. new x pos
  If Abs(Current.X - Target.X) < MOVE_STEP_SIZE Then
    NewPos.X = Target.X
  Else
    If Target.X < Current.X Then
      NewPos.X = Current.X - MOVE_STEP_SIZE
    Else
      NewPos.X = Current.X + MOVE_STEP_SIZE
    End If
  End If
  
  ' Calc. new y pos
  If Abs(Current.Y - Target.Y) < MOVE_STEP_SIZE Then
    NewPos.Y = Target.Y
  Else
    If Target.Y < Current.Y Then
      NewPos.Y = Current.Y - MOVE_STEP_SIZE
    Else
      NewPos.Y = Current.Y + MOVE_STEP_SIZE
    End If
  End If
  
  ' Set new pos.
  Call Mouse.Move(NewPos.X, NewPos.Y)
End Sub



'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.cool-programming.f2s.com"
End Sub


